/* Auteur: Nicolas JANEY          */
/* nicolas.janey@univ-fcomte.fr   */
/* Mars 2006                      */

import java.io.*;
import java.text.*;

public class ValeurMaximaleMatriceEnConsole {
  static DecimalFormat df = new DecimalFormat("0.0000 ");

  /* Creation d'une chaine de caracteres                  */
  /* representant un nombre reel complemente par          */
  /* des espaces pour obtenir une longueur totale fixee   */

  public static String format(float v) {
    if ( v < 10.0F )
      return("  "+df.format(v));
      else
      if ( v < 100.0F )
        return(" "+df.format(v));
        else
        return(df.format(v));
  }

  /* Affichage d'une matrice de reelss formatee           */
  /* en lignes et en colonnes                             */

  public static void affichageMatrice(float [][] m) {
    for ( int i = 0 ; i < m.length ; i++ ) {
      for ( int j = 0 ; j < m[i].length ; j++ )
        Console.out.print(format(m[i][j]));
      Console.out.println(); }
  }

  /* Creation d'une matrice de reels tires au sort entre  */
  /* 0 et une valeur limite pour un nombre arbitraire     */
  /* de lignes et de colonnes                             */

  public static float [][] matriceAuHasard(int lignes,int colonnes,float max) {
    float [][] m = new float[lignes][colonnes];
    for ( int i = 0 ; i < lignes ; i++ )
      for ( int j = 0 ; j < colonnes ; j++ )
        m[i][j] =(float) Math.random()*max;
    return(m);
  }

  /* Calcul de la valeur maximale contenue                */
  /* dans une matrice de reels                            */

  public static float valeurMaximaleMatrice(float [][] m) {
    float max = m[0][0];
    for ( int i = 0 ; i < m.length ; i++ )
      for ( int j = 0 ; j < m[i].length ; j++ )
        if ( m[i][j] > max )
          max = m[i][j];
    return(max);
  }

  /* Fonction principale                                  */

  public static void main(String [] args) {
    Console.setTitle("ValeurMaximaleMatrice");
    float [][] mat = matriceAuHasard(6,4,100.0F);
    Console.out.println("Matrice");
    affichageMatrice(mat);
    Console.out.println();
    float max = valeurMaximaleMatrice(mat);
    Console.out.println("Valeur maximale : "+max);
  }
}